/*
 * SprinklerMain.java
 *
 * Created on July 7, 2005, 11:59 PM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package sprinklercontroller;

import timereventmodel.TimerEventListener;
import timereventmodel.TimerActionCommand;

/**
 *
 * @author Evan
 */
public class SprinklerMain implements TimerEventListener{
    private SprinklerZone[] zone;
    private SprinklerManualControl smc; 
    private SprinklerTimerControl stc;
    private SprinklerInterfaceControlDriver driver;
    
    /** Creates a new instance of SprinklerMain */
    public SprinklerMain() {
        driver = new SprinklerInterfaceControlDriver();
        
        zone = new SprinklerZone[5];
        for(int i=0; i<5; i++){
            zone[i] = new SprinklerZone(i+1);
        }
        
        smc = new SprinklerManualControl(zone);
        smc.addTimerListener(this);
        stc = new SprinklerTimerControl(zone);
        stc.addTimerListener(this);
        
        while(true){
            smc.check();
            stc.check();
            
            for(int i=0; i<5; i++){
                zone[i].getDataFromDB();
            }
            
            smc.updateZoneData(zone);
            stc.updateZoneData(zone);
        }
    }
    
    public void timerActionPerformed(TimerActionCommand tac){
        driver.issueCommand(tac.getMessage());
    }
}
