/*
 * SprinklerTimerControl.java
 *
 * Created on July 7, 2005, 9:14 PM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package sprinklercontroller;

import java.util.Date;
import timereventmodel.TimerCheck;
import timereventmodel.TimerEventListener;
import timereventmodel.TimerActionCommand;

/**
 *
 * @author Evan
 */
public class SprinklerTimerControl implements TimerCheck{
    
    private SprinklerZone[] zone;
    private Date date;
    private TimerEventListener tel;
    /** Creates a new instance of SprinklerTimerControl */
    public SprinklerTimerControl() {
    }
    
    public SprinklerTimerControl(SprinklerZone[] zone){
        updateZoneData(zone);
        date = new Date();
    }
    
    public void check(){
        date.setTime(System.currentTimeMillis());
        
        int currHour = date.getHours();
        int currMinute = date.getMinutes();
        
        for(int i=0; i<5; i++){
            String[] time = zone[i].getStartTime().split(":");
            int zoneStartHour = Integer.parseInt(time[0]);
            int zoneStartMinute = Integer.parseInt(time[1]);
            
            if(time[2].equals("PM"))
                zoneStartHour += 12;
            
            time = zone[i].getEndTime().split(":");
            int zoneEndHour = Integer.parseInt(time[0]);
            int zoneEndMinute = Integer.parseInt(time[1]);
            
            if(time[2].equals("PM"))
                zoneEndHour += 12;
            
            if(currHour == zoneStartHour && currMinute == zoneStartMinute){
                tel.timerActionPerformed(new TimerActionCommand("ON:"+(i+1)));
                zone[i].setStatusBool(true);
                zone[i].updateDB();
            }
            
            if(currHour == zoneEndHour && currMinute == zoneEndMinute){
                tel.timerActionPerformed(new TimerActionCommand("OFF:"+(i+1)));
                zone[i].setStatusBool(false);
                zone[i].updateDB();
            }
        }          
    }
    
    /**this is a bad OO model because we only have one listener
     *I'll fix this later*/
    public void addTimerListener(TimerEventListener tel){
        this.tel = tel;
    }
    
    public void updateZoneData(SprinklerZone[] zone){
        this.zone = zone;
    }
}
